<%-- $Id:edit_filetype.jsp 3820 2007-10-12 10:03:18Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.DataFileType"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Metadata"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.tabcontrol.TabAction"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Set"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.DATAFILETYPE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	DataFileType fileType = null;
	boolean readCurrentFileType = true;
	int currentFileTypeId = 0;

	if (itemId == 0)
	{
		title = "Create data file type";
		cc.removeObject("item");
		currentFileTypeId = Values.getInt(cc.getPropertyValue("genericType"), 0);
		if (currentFileTypeId == 0)
		{
			currentFileTypeId = Values.getInt(cc.getRecent(Item.ITEMSUBTYPE.name(), 0), 0);
		}
	}
	else
	{
		fileType = DataFileType.getById(dc, itemId);
		fileType.checkPermission(Permission.WRITE);
		cc.setObject("item", fileType);
		title = "Edit data file type -- " + HTML.encodeTags(fileType.getName());
		try
		{
			ItemSubtype ft = fileType.getGenericType();
			if (ft != null) currentFileTypeId = ft.getId();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentFileType = false;
		}
	}
	// Query to retrieve file types
	final ItemQuery<ItemSubtype> fileTypeQuery = ItemSubtype.getQuery(Item.FILE);
	fileTypeQuery.order(Orders.asc(Hql.property("name")));
	fileTypeQuery.setCacheResult(true);

	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), fileType);
	ExtensionsInvoker<TabAction> invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,~filetypes.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="fileType">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol"
			position="bottom"  remember="<%=fileType != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Data file type" helpid="datafiletype.edit">
			<table class="fullform input100 smaller">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" type="text" name="name" data-auto-init="<%=fileType == null ? "focus-select" : "focus" %>"
					value="<%=HTML.encodeTags(fileType == null ? Values.getString(cc.getPropertyValue("name"), "New data file type") : fileType.getName())%>" 
					maxlength="<%=DataFileType.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<%
			if (fileType == null)
			{
				// For new file types only
				Set<Item> items = Metadata.getFileStoreEnabledItems();
				int itemCode = Values.getInt(cc.getPropertyValue("itemType"), -1);
				%>
				<tr>
					<th>External ID</th>
					<td><input class="text required unchangeable" type="text" name="externalId" 
						value="<%=HTML.encodeTags(cc.getPropertyValue("externalId"))%>" 
						maxlength="<%=DataFileType.MAX_EXTERNAL_ID_LENGTH%>"></td>
					<td></td>
				</tr>
				<tr>
					<th>Item type</th>
					<td>
						<select name="itemType" class="required unchangeable selectionlist">
						<%
						for (Item item : items)
						{
							String selected = itemCode == item.getValue() ? "selected" : "";
							%>
							<option value="<%=item.name()%>" <%=selected%>><%=item.toString() %>
							<%
						}
						%>
						</select>
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			<tr>
				<th>File extension</th>
				<td><input class="text" type="text" name="extension" style="width: 15em;"
					value="<%=HTML.encodeTags(fileType == null ? Values.getString(cc.getPropertyValue("extension")) : fileType.getExtension())%>" 
					maxlength="<%=DataFileType.MAX_EXTENSION_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Generic file type</th>
				<td>
					<select name="generictype_id" <%=!readCurrentFileType ? "disabled readonly class=\"disabled\"" : "class=\"selectionlist\""%>>
					<%
					if (!readCurrentFileType)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">- none -
						<%
						ItemResultList<ItemSubtype> fileTypes = fileTypeQuery.list(dc);
						for (ItemSubtype ft : fileTypes)
						{
							int id = ft.getId();
							%>
							<option 
								value="<%=fileType != null && id == currentFileTypeId ? -id : id%>" 
								<%=id == currentFileTypeId ? "selected" : ""%>
								><%=HTML.encodeTags(ft.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="6" name="description" id="description"
						><%=HTML.encodeTags(fileType == null ? cc.getPropertyValue("description") : fileType.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
			<%if (fileType == null) {%><br>
				<base:icon image="unchangeable.png" />= can't be changed later
			<%}%>
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
