/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2013 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var SpotImages = function()
{
	var spotimages = {};
	
	/**
		Initialize the page.
	*/
	spotimages.initPage = function()
	{
		// Save + Close buttons
		Buttons.addClickHandler('btnSave', spotimages.save);
		Buttons.addClickHandler('close', App.closeWindow);

		// Image file selection
		Buttons.addClickHandler('btnRedFile', spotimages.selectFile);
		Events.addEventHandler('redfile_id', 'base-selected', spotimages.setFileCallback);

		Buttons.addClickHandler('btnGreenFile', spotimages.selectFile);
		Events.addEventHandler('greenfile_id', 'base-selected', spotimages.setFileCallback);

		Buttons.addClickHandler('btnBlueFile', spotimages.selectFile);
		Events.addEventHandler('bluefile_id', 'base-selected', spotimages.setFileCallback);
		
		// Save as
		Buttons.addClickHandler('btnBrowse', spotimages.browseOnClick);
		Events.addEventHandler('path', 'base-selected', spotimages.setSaveAsCallback);
	}
	

	spotimages.selectFile = function(event)
	{
		var selectElement = Doc.element(Data.get(event.currentTarget, 'select'));
		var url = '&resetTemporary=1';
		url += '&tmpfilter:INT:itemSubtype='+Data.get('page-data', 'image-file-type');
		if (selectElement.length > 1) 
		{
			url += '&item_id='+selectElement[1].value;
		}
		Dialogs.selectItem('FILE', selectElement.id, 0, url);
	}
	
	spotimages.setFileCallback = function(event)
	{
		var selectElement = event.currentTarget;
		var frm = document.forms['spotimages'];
		if (selectElement.length < 2)
		{
			selectElement[selectElement.length] = new Option();
		}
		selectElement[1].value = event.detail.id;
		selectElement[1].text = event.detail.name;
		selectElement.selectedIndex = 1;
	}

	spotimages.save = function()
	{
		var frm = document.forms['spotimages'];
		frm.submit();
	}

	spotimages.browseOnClick = function()
	{
		var url = '../../filemanager/index.jsp?ID='+App.getSessionId();
		url += '&cmd=SaveAs&callback=path';
		Dialogs.openPopup(url, 'SaveAs', 1050, 700);
	}
	
	spotimages.setSaveAsCallback = function(event)
	{
		var frm = document.forms['spotimages'];
		frm.path.value = event.detail.path;
	}
	
	return spotimages;
}();

Doc.onLoad(SpotImages.initPage);
Doc.addElementInitializer(Forms.numberOnlyInitializer);
